Subject: Re: [PATCH net-next v01 1/1] hinic3: module initialization and tx/rx logic

From: Jakub Kicinski <[email-masked]>
Date: Mon, 30 Dec 2024 19:23:26 -0800

On Mon, 30 Dec 2024 16:14:35 +0200 Gur Stavi wrote:
> > > The most popular combination in the last 3 decades was little endian
> > > CPUs with big endian device interfaces. Endianity conversion was a
> > > necessity and therefore endian annotation became standard practice.
> > > But it was never symmetric, conversion to/from BE was more common than
> > > conversion to/from LE.
> > >
> > > As the pendulum moved from horizontal market to vertical market and major
> > > companies started to develop both hw and sw, the hw engineers transformed
> > > proprietary parts of the interface to little endian to save extra work in
> > > the sw. AWS did it. Azure did it. Huawei did it. These vertical companies
> > > do not care about endianity of CPUs they do not use.
> > > This is not "corporate verbiage" this is a real market shift.  
> >
> > Don't misquote me. You did it in your previous reply, now you're doing
> > it again.
> >
> > If you don't understand what I'm saying you can ask for clarifications.
> 
> We studied previous submissions and followed their example.
> Were the maintainers wrong to approve Amazon and Microsoft drivers?

It's not a right or wrong question, more a cost/benefit question.
I'm not sure the community benefits from merging every single company's
paravirt driver, when virtio exists. I'd say having those drivers
upstream is somewhere around neutral.

BTW very often guidance for new drivers is set by problems with already
merged drivers. Not that it's necessarily the case here, just sharing
some general knowledge about the upstream process.

> I don't understand what the problem is. Please clarify.

Primarily the fact that you keep arguing as if joining the community
was done by winning a fight. If annotating HW structures with endian
is beyond your / your teams capabilities, that's okay, just replace
the "will not be converted" with "are currently not converted" in 
the comment.

For your reference here are the development stats showing that
Huawei is the biggest net-taker of code reviews in networking:
https://lore.kernel.org/all/[email-masked]/